package com.zsc.edu.dify.framework.mybatisplus;


import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.zsc.edu.dify.framework.security.SecurityUtil;
import com.zsc.edu.dify.framework.security.UserDetailsImpl;
import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.util.Date;

/**
 * @author Yao
 */
@Slf4j
@Component
public class MyMetaObjectHandler implements MetaObjectHandler {

    @Override
    public void insertFill(MetaObject metaObject) {

        UserDetailsImpl userInfo = SecurityUtil.getUserInfo();
        this.strictInsertFill(metaObject, "createTime", Date.class, new Date());
        this.strictInsertFill(metaObject, "createBy", String.class, userInfo.getUsername());
        this.strictInsertFill(metaObject, "deptId", Long.class, userInfo.getDeptId());
        this.strictInsertFill(metaObject, "createId", Long.class, userInfo.getCreateId());
        this.strictInsertFill(metaObject,"userId",Long.class,userInfo.getId());
    }

    @Override
    public void updateFill(MetaObject metaObject) {
        UserDetailsImpl userInfo = SecurityUtil.getUserInfo();
        this.strictUpdateFill(metaObject, "updateTime", Date::new, Date.class);
        this.strictUpdateFill(metaObject, "updateBy", userInfo::getUsername, String.class);

    }

}